function Capitalist:StartPost()
--	self:Print("StartPost")
ClearCursor()
	self.scrollsToPost = self:GetScrollsInInventory()
	
	self.auctionUI.lastScanLabel:Hide()
	self.auctionUI.progressLabel:Show()
	self.auctionUI.progressLabel:SetText("posting..")
	self.auctionUI.progress:Show()
	self.auctionUI.progress:SetWidth(1)
	self.auctionUI.postButton:Disable()
	self.auctionUI.scanButton:Disable()
	
	self.mode = "posting"
	self.postActive = false
	self.PostingDrained = true
	self.PostingSplitActive = false
	self.PostingPostActive = false
	self.updateHandler:Show()
end

function Capitalist:GetScrollsInInventory()
--	self:Print("GetScrollsInInventory")
	-- count the number of scrolls in our inventory
	local numScrolls = 0
	
	for bag = 0, 4 do
		for slot = 1, GetContainerNumSlots(bag) do
			local link = GetContainerItemLink(bag, slot)
			if (link) then
				local name = link:match("%[(.*)%]")
				if (self.list[name]) then
					local _, count = GetContainerItemInfo(bag, slot)
					numScrolls = numScrolls + count
				end
			end
		end
	end
	
	return numScrolls
end

function Capitalist:OnUpdatePosting()
	if (self.elapsed > 1) then
--self:Print("OnUpdatePosting")
		self.elapsed = 0
		if (not self.PostingSplitActive and not self.PostingPostActive) then
			self.PostingDrained = true
			self.PostingSplitActive = true
			self:SplitItems()
			if (not self.PostingSplitActive) then
				self.PostingPostActive = true
				self:Post()
			end
		end

		if (self.PostingDrained) then
			self.updateHandler:Hide()
		
			self.auctionUI.progress:Hide()
			self.auctionUI.progressLabel:Hide()
			self.auctionUI.lastScanLabel:Show()
			self.auctionUI.scanButton:Enable()
			self.auctionUI.postButton:Enable()
		end
	end
end

function Capitalist:Post()
--	self:Print("Post")

if (not self.postActive) then
self.postActive = true;

	local finished = true
	local scrollsInAH = self.db.profile.storage[GetCVar("realmName")][UnitName("player")].AH

local nonePosted = true;

	for bag = 0, 4 do
--self:Print(bag)
		for slot = 1, GetContainerNumSlots(bag) do
--self:Print(slot)
			local link = GetContainerItemLink(bag, slot)
if (nonePosted) then
			if (link) then
--self:Print(link)
				local name = link:match("%[(.*)%]")
--self:Print(name)
				if (self.list[name] and self:ShouldPostThisItem(name)) then
					local _, count, locked = GetContainerItemInfo(bag, slot)
--self:Print(count)
--self:Print(locked)
					if (locked) then
						-- not done with destacking - don't stop posting
						finished = false
					else
						if (count == 1) then
--self:Print("A")
							PickupContainerItem(bag, slot)
--self:Print("B")
							ClickAuctionSellItemButton()
							-- preliminary bug check
--self:Print("C")
							if (type(self.list[name].bestPrice) == "number") then
--self:Print("D")
								finished = false
								self.PostingDrained = false

nonePosted = false;
--
-- BrianMan: Edited for compatibility with StartAuction, I hope.
-- 10/12/2010
--
--								StartAuction(self.list[name].bestPrice, self.list[name].bestPrice, 48*60)
								StartAuction(self.list[name].bestPrice, self.list[name].bestPrice, 48*60, 1, 1)
--self:Print("E")
							
								self.list[name].buyoutSelf = self.list[name].bestPrice
--self:Print("F")
								if (not scrollsInAH[name]) then
									scrollsInAH[name] = 1
								else
									scrollsInAH[name] = scrollsInAH[name] + 1
								end
							end
						end
					end
				end
			end
end
		end
	end
	
	if (finished) then
		self.PostingPostActive = false
		--self:SplitItems()
	
		--self.updateHandler:Hide()
		
		--self.auctionUI.progress:Hide()
		--self.auctionUI.progressLabel:Hide()
		--self.auctionUI.lastScanLabel:Show()
		--self.auctionUI.scanButton:Enable()
		--self.auctionUI.postButton:Enable()
	else
		local alreadyPosted = self.scrollsToPost - self:GetScrollsInInventory()
		self.auctionUI.progress:SetWidth(110 * alreadyPosted / self.scrollsToPost)
	end

self.postActive = false
end

end

function Capitalist:SplitItems()
--	self:Print("SplitItems")
	local emptySlots = {}
	local splitSlots = {}

	local finished = true
	
	for bag = 0, 4 do
		local _, bagType = GetContainerNumFreeSlots(bag)
		if (bagType == 0) then
			for slot = 1, GetContainerNumSlots(bag) do
				link = GetContainerItemLink(bag, slot)
				if (link == nil) then
					table.insert(emptySlots, {bag, slot})
				else
					local name = link:match("%[(.*)%]")
					if (self.list[name] and self:ShouldPostThisItem(name)) then
						_, count, locked = GetContainerItemInfo(bag, slot)
						if (count > 1) then
							finished = false
							if (not locked) then
								table.insert(splitSlots, {bag, slot, 1})
							end
						end
					end
				end
			end
		end
	end
	
	for i = 1, #splitSlots do
		if (emptySlots[i]) then
			self.PostingDrained = false
			SplitContainerItem(splitSlots[i][1], splitSlots[i][2], splitSlots[i][3])
			PickupContainerItem(emptySlots[i][1], emptySlots[i][2])
		end
	end
	
	if (finished) then
		self.PostingSplitActive = false
		--self.updateHandler:Hide()
		
		--self.auctionUI.progress:Hide()
		--self.auctionUI.progressLabel:Hide()
		--self.auctionUI.lastScanLabel:Show()
		--self.auctionUI.scanButton:Enable()
		--self.auctionUI.postButton:Enable()
	end

end

function Capitalist:ShouldPostThisItem(name)
--	self:Print("ShouldPostThisItem")
	local scrollsInAH = self.db.profile.storage[GetCVar("realmName")][UnitName("player")].AH[name]
	if (scrollsInAH and scrollsInAH >= self.db.profile.recipes[self.list[name].recipe].scrollCount) then
		return false
	end
	
	return true
end
